package cn.com.qmth.scancloud.dao;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import cn.com.qmth.scancloud.bean.BatchQueryDomain;
import cn.com.qmth.scancloud.bean.MismatchQueryDomain;
import cn.com.qmth.scancloud.entity.BatchEntity;
import cn.com.qmth.scancloud.enums.VerifyStatus;
import cn.com.qmth.scancloud.vo.BatchQueryVo;
import cn.com.qmth.scancloud.vo.batchdetail.BatchDetailVo;
import cn.com.qmth.scancloud.vo.mismatchquery.MismatchQueryVo;

public interface BatchDao extends BaseMapper<BatchEntity> {

    void updateScanCount(@Param("id") Long id);

    void updateAssignedCount(@Param("id") Long id);

    IPage<BatchQueryVo> batchQueryPage(Page<BatchQueryVo> page, @Param("query") BatchQueryDomain query);

    List<BatchDetailVo> batchDetailList(@Param("id") Long id);

    IPage<MismatchQueryVo> mismatchQueryPage(Page<MismatchQueryVo> page, @Param("query") MismatchQueryDomain query);

    IPage<BatchEntity> findUnVerify(Page<BatchEntity> page,@Param("examId") Long examId,@Param("status") VerifyStatus status);

	List<BatchQueryVo> findAssignedCount(@Param("batchIds")List<Long> batchIds);

	List<String> batchScanner(@Param("examId")Long examId);

}
