package cn.com.qmth.scancloud.dao;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import cn.com.qmth.scancloud.bean.AbsentQueryDomain;
import cn.com.qmth.scancloud.bean.AnswerQueryDomain;
import cn.com.qmth.scancloud.entity.StudentEntity;
import cn.com.qmth.scancloud.vo.AbsentQueryVo;
import cn.com.qmth.scancloud.vo.AnswerExportVo;
import cn.com.qmth.scancloud.vo.ImportStudentQueryVo;
import cn.com.qmth.scancloud.vo.ImportStudentVo;
import cn.com.qmth.scancloud.vo.StudentUploadVo;
import cn.com.qmth.scancloud.vo.answerquery.AnswerQueryVo;

public interface StudentDao extends BaseMapper<StudentEntity> {

    List<String> listCampusByExamId(@Param("examId") Long examId);

    List<String> listSiteByExamId(@Param("examId") Long examId);

    IPage<AbsentQueryVo> absentQueryPage(Page<AbsentQueryVo> page, @Param("groupNameCol") String groupNameCol,
            @Param("query") AbsentQueryDomain query);

    IPage<AnswerQueryVo> queryPage(Page<AnswerQueryVo> page, @Param("query") AnswerQueryDomain query);

    List<StudentUploadVo> findToUpload(@Param("pageSize") Integer pageSize, @Param("schoolId") Long schoolId);

    List<AbsentQueryVo> absentQueryList(@Param("groupNameCol") String groupNameCol,
            @Param("query") AbsentQueryDomain query);

    List<AnswerExportVo> queryList(@Param("query") AnswerQueryDomain query);

    int getPackageCountByExam(@Param("examId") Long examId);

    int countByQuery(@Param("query") ImportStudentQueryVo query);

    IPage<ImportStudentVo> listPageQuery(Page<ImportStudentVo> page, @Param("query") ImportStudentQueryVo query);

	List<StudentUploadVo> findToPictureCopy(@Param("pageSize") Integer pageSize);

	int getUploadedCount(@Param("examId")Long examId);

}
