package cn.com.qmth.scancloud.entity;

import java.util.List;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.GsonTypeHandler;
import com.github.jeffreyning.mybatisplus.anno.MppMultiId;

import cn.com.qmth.scancloud.bean.answersave.ArrayResult;
import cn.com.qmth.scancloud.bean.answersave.BoolResult;
import cn.com.qmth.scancloud.bean.answersave.StringResult;
import cn.com.qmth.scancloud.entity.base.AuditingWithoutIdEntity;

@TableName(value ="sc_paper_page",autoResultMap = true)
public class PaperPageEntity extends AuditingWithoutIdEntity {

    /**
     * 
     */
    private static final long serialVersionUID = -182520914017960004L;

    @MppMultiId
    private Long paperId;

    @MppMultiId
    private Integer pageIndex;
    
    private Long batchId;
    
    private Long examId;
    
    private Long studentId;

    @TableField(value = "absent", typeHandler = GsonTypeHandler.class)
    private BoolResult absent;

    @TableField(value = "breach", typeHandler = GsonTypeHandler.class)
    private BoolResult breach;

    @TableField(value = "paper_type", typeHandler = GsonTypeHandler.class)
    private StringResult paperType;

    @TableField(value = "question", typeHandler = GsonTypeHandler.class)
    private ArrayResult question;

    @TableField(value = "selective", typeHandler = GsonTypeHandler.class)
    private ArrayResult selective;

    private String sheetPath;

    @TableField(value = "slice_path", typeHandler = GsonTypeHandler.class)
    private List<String> slicePath;

    private String recogData;
    
    
	public Long getPaperId() {
		return paperId;
	}

	public void setPaperId(Long paperId) {
		this.paperId = paperId;
	}


	public Integer getPageIndex() {
		return pageIndex;
	}

	public void setPageIndex(Integer pageIndex) {
		this.pageIndex = pageIndex;
	}

	public BoolResult getAbsent() {
		return absent;
	}

	public void setAbsent(BoolResult absent) {
		this.absent = absent;
	}

	public BoolResult getBreach() {
		return breach;
	}

	public void setBreach(BoolResult breach) {
		this.breach = breach;
	}

	public StringResult getPaperType() {
		return paperType;
	}

	public void setPaperType(StringResult paperType) {
		this.paperType = paperType;
	}

	public ArrayResult getQuestion() {
		return question;
	}

	public void setQuestion(ArrayResult question) {
		this.question = question;
	}

	public ArrayResult getSelective() {
		return selective;
	}

	public void setSelective(ArrayResult selective) {
		this.selective = selective;
	}

	public String getSheetPath() {
		return sheetPath;
	}

	public void setSheetPath(String sheetPath) {
		this.sheetPath = sheetPath;
	}

	public List<String> getSlicePath() {
		return slicePath;
	}

	public void setSlicePath(List<String> slicePath) {
		this.slicePath = slicePath;
	}

	public Long getBatchId() {
		return batchId;
	}

	public void setBatchId(Long batchId) {
		this.batchId = batchId;
	}

	public Long getStudentId() {
		return studentId;
	}

	public void setStudentId(Long studentId) {
		this.studentId = studentId;
	}

	public Long getExamId() {
		return examId;
	}

	public void setExamId(Long examId) {
		this.examId = examId;
	}

	public String getRecogData() {
		return recogData;
	}

	public void setRecogData(String recogData) {
		this.recogData = recogData;
	}

    
}
