package cn.com.qmth.scancloud.service;

import java.util.List;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.boot.core.collection.PageResult;

import cn.com.qmth.scancloud.bean.BatchCreateDomain;
import cn.com.qmth.scancloud.bean.BatchQueryDomain;
import cn.com.qmth.scancloud.bean.MismatchQueryDomain;
import cn.com.qmth.scancloud.bean.User;
import cn.com.qmth.scancloud.bean.answersave.AnswerDomain;
import cn.com.qmth.scancloud.entity.BatchEntity;
import cn.com.qmth.scancloud.enums.VerifyStatus;
import cn.com.qmth.scancloud.vo.BatchFinishVo;
import cn.com.qmth.scancloud.vo.BatchQueryVo;
import cn.com.qmth.scancloud.vo.BatchVerifyVo;
import cn.com.qmth.scancloud.vo.batch.AnswerSaveVo;
import cn.com.qmth.scancloud.vo.batch.BatchCreateVo;
import cn.com.qmth.scancloud.vo.batchdetail.BatchDetailVo;
import cn.com.qmth.scancloud.vo.mismatchquery.MismatchQueryVo;
import cn.com.qmth.scancloud.vo.verify.VerifyTaskVo;

public interface BatchService extends IService<BatchEntity> {

    BatchCreateVo batchCreate(BatchCreateDomain domain, User user);

    int getCountByExam(Long examId);

    int getVerifyCount(Long examId);

    AnswerSaveVo batchSave(AnswerDomain domain, User user);

    void verify(Long batchId, Boolean comfirm, User user);

    BatchVerifyVo batchVerify(Long id);

    BatchFinishVo batchFinish(Long id);

    List<BatchEntity> listByExam(Long examId);

    void updateScanCount(Long id);

    void updateAssignedCount(Long id);

    PageResult<BatchQueryVo> batchQuery(BatchQueryDomain query);

    List<BatchDetailVo> batchDetail(Long id);

    PageResult<MismatchQueryVo> mismatchQuery(MismatchQueryDomain query);

    VerifyTaskVo getVerifyTask(Long examId, User user);

    boolean apply(BatchEntity t, String user);

    void releaseByUser(Long examId, String user);

    void releaseByTask(BatchEntity t);

    boolean hasApplied(BatchEntity t, String user);

    IPage<BatchEntity> findUnVerify(Long examId, int pageNumber, int pageSize, VerifyStatus status);

	void checkBatchStatus(BatchEntity b);

	List<String> batchScanner(Long examId);

	int getValidCountByExam(Long examId);

}
