package cn.com.qmth.scancloud.service;

import java.util.List;

import org.springframework.web.multipart.MultipartFile;

import com.baomidou.mybatisplus.extension.service.IService;

import cn.com.qmth.scancloud.bean.AnswerDeleteDomain;
import cn.com.qmth.scancloud.bean.MismatchToggleDomain;
import cn.com.qmth.scancloud.bean.PageDeleteDomain;
import cn.com.qmth.scancloud.bean.User;
import cn.com.qmth.scancloud.bean.WorkloadDomain;
import cn.com.qmth.scancloud.entity.PaperEntity;
import cn.com.qmth.scancloud.vo.AnswerDeleteVo;
import cn.com.qmth.scancloud.vo.MismatchToggleVo;
import cn.com.qmth.scancloud.vo.PageDeleteVo;
import cn.com.qmth.scancloud.vo.ScannerWorkloadVo;
import cn.com.qmth.scancloud.vo.SheetUploadVo;
import cn.com.qmth.scancloud.vo.SliceUploadVo;
import cn.com.qmth.scancloud.vo.UriVo;
import cn.com.qmth.scancloud.vo.answerquery.StudentPaperVo;
import cn.com.qmth.scancloud.vo.mismatchquery.MismatchQueryVo;
import cn.com.qmth.scancloud.vo.paper.PaperVo;

/**
 * 鉴权
 *
 */
public interface PaperService extends IService<PaperEntity> {

    List<PaperVo> findStudentPaper(Long studentId);

    int getMismatchCountByExam(Long examId);
    
    PaperEntity findByStudentAndBatchAndNumber(Long studentId,Long batchId,Integer number);

	MismatchToggleVo mismatchToggle(MismatchToggleDomain domain);

	SheetUploadVo sheetUpload(Long batchId, String examNumber, Integer paperNumber, Integer pageIndex,
			MultipartFile file, String md5);

	SliceUploadVo sliceUpload(Long batchId, String examNumber, Integer paperNumber, Integer pageIndex, Integer index,
			MultipartFile file, String md5);

	Integer findCountByBatch(Long batchId);

	List<ScannerWorkloadVo> workload(WorkloadDomain domain);

	Integer findStudentCountByBatch(Long batchId);

	List<PaperEntity> findByBatch(Long id);

	List<PaperEntity> listByMismatchQuery(List<MismatchQueryVo> paramList);

	List<StudentPaperVo> listByStudentIds(List<Long> paramList);

	UriVo adminSliceUpload(Long paperId, Integer pageIndex, Integer index, MultipartFile file,
			String md5);

	PageDeleteVo pageDelete(User user,PageDeleteDomain domain);

	AnswerDeleteVo answerDelete(User user,AnswerDeleteDomain domain);

	void deleteByBatchIdAndStudentId(Long batchId, Long studentId);

	UriVo adminSliceUpdate(Long paperId, Integer pageIndex, Integer index, MultipartFile file, String md5);

	List<PaperEntity> findAssigneByBatch(Long batchId);

	List<PaperEntity> findStudentPaperEffective(Long studentId);

    int getCountByExamAndCardNumber(Long examId, Integer number);

}
