package cn.com.qmth.scancloud.service;

import java.util.List;

import org.springframework.web.multipart.MultipartFile;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.boot.core.collection.PageResult;

import cn.com.qmth.scancloud.bean.AbsentQueryDomain;
import cn.com.qmth.scancloud.bean.AnswerQueryDomain;
import cn.com.qmth.scancloud.bean.ImportStudentDomain;
import cn.com.qmth.scancloud.entity.StudentEntity;
import cn.com.qmth.scancloud.enums.ScanStatus;
import cn.com.qmth.scancloud.enums.UploadStatus;
import cn.com.qmth.scancloud.vo.AbsentInfoVo;
import cn.com.qmth.scancloud.vo.AbsentManualImportVo;
import cn.com.qmth.scancloud.vo.AbsentQueryVo;
import cn.com.qmth.scancloud.vo.AnswerExportVo;
import cn.com.qmth.scancloud.vo.ImportStudentQueryVo;
import cn.com.qmth.scancloud.vo.ImportStudentVo;
import cn.com.qmth.scancloud.vo.ScanAnswerInfoVo;
import cn.com.qmth.scancloud.vo.StudentUploadVo;
import cn.com.qmth.scancloud.vo.UpdateTimeVo;
import cn.com.qmth.scancloud.vo.answerquery.AnswerQueryVo;
import cn.com.qmth.scancloud.vo.student.StudentQuery;
import cn.com.qmth.scancloud.vo.student.StudentVo;

public interface StudentService extends IService<StudentEntity> {

    List<String> listCampusByExamId(Long examId);

    List<String> listSiteByExamId(Long examId);

    StudentVo findOne(StudentQuery query);

    int getCountByExam(Long examId);

    int getCountByExamAndScanStatus(Long examId, ScanStatus status);

    int getPackageCountByExam(Long examId);

    List<StudentVo> packageList(StudentQuery query);

    StudentEntity findByExamAndExamNumber(Long examId, String examNumber);

    List<StudentEntity> findByExamAndPackage(Long examId, String packageCode);

    int getAssignedCountByExam(Long examId);

    int getAbsentSuspectCountByExam(Long examId);

    int getIncompleteCountByExam(Long examId);

    AbsentInfoVo absentInfo(Long examId);

    PageResult<AbsentQueryVo> absentQuery(AbsentQueryDomain query);

    AbsentManualImportVo absentManualImport(Long examId, MultipartFile file);

    UpdateTimeVo absentManualUpdate(Long examId, String examNumber);

    UpdateTimeVo absentSuspectRemove(Long examId, String examNumber);

    ScanAnswerInfoVo scanAnswerInfo(Long examId);

    PageResult<AnswerQueryVo> query(AnswerQueryDomain query);

    List<StudentUploadVo> findToUpload(int pageSize, Long schoolId);

    boolean existUploadData(Long schoolId);

    StudentEntity findByStudentCodeAndSubjectCode(Long examId,String studentCode, String subjectCode);

    List<AbsentQueryVo> absentExportList(AbsentQueryDomain query);

    List<AnswerExportVo> exportList(AnswerQueryDomain query);

    void updateDataUploadStatus(Long id, UploadStatus status);

    void updateUploadStatus(Long id, UploadStatus fileUploadStatus, UploadStatus dataUploadStatus);

    void updateFileUploadStatus(Long id, UploadStatus status);

    void updateOmrAbsent(Long id, Boolean omrAbsent);

    void deltetByExamIdAndUnCreateTime(Long examId, long createTime);

    int getCountByExamAndCardNumber(Long examId, Integer number);

    int importStudent(List<ImportStudentDomain> students);

    StudentEntity findByExamAndSubjectCodeAndStudentCode(Long examId, String subjectCode, String studentCode);

    int countByQuery(ImportStudentQueryVo query);

    List<ImportStudentVo> findByQuery(ImportStudentQueryVo query);

    int getOmrAbsentCountByExam(Long examId);

	boolean existPictureCopyData();

	List<StudentUploadVo> findToPictureCopy(int pageSize);

	public Double getUploadProgress(Long examId);

	void studentClean(Long examId);

}
