package cn.com.qmth.scancloud.service.impl;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.codec.digest.DigestUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.boot.tools.codec.CodecUtils;

import cn.com.qmth.scancloud.bean.ImportUserDomain;
import cn.com.qmth.scancloud.dao.UserDao;
import cn.com.qmth.scancloud.entity.UserEntity;
import cn.com.qmth.scancloud.service.UserService;

@Service
public class UserServiceImpl extends ServiceImpl<UserDao, UserEntity> implements UserService {

    @Override
    public UserEntity getByLoginName(String loginName) {
        if (loginName == null) {
            return null;
        }
        QueryWrapper<UserEntity> wrapper = new QueryWrapper<>();
        LambdaQueryWrapper<UserEntity> lw = wrapper.lambda();
        lw.eq(UserEntity::getLoginName, loginName);
        return baseMapper.selectOne(wrapper);
    }
    @Transactional
    @Override
    public int importUser(List<ImportUserDomain> users) {
        List<UserEntity> list = new ArrayList<UserEntity>();
        for (ImportUserDomain importUserDomain : users) {
            UserEntity user = this.getByLoginName(importUserDomain.getLoginName());
            if(user==null) {
                user = new UserEntity();
                user.setEnable(true);
                user.setLoginName(importUserDomain.getLoginName());
                user.setRole(importUserDomain.getRole());
                user.setName(importUserDomain.getName());
                user.setSchoolId(importUserDomain.getSchoolId());
                byte[] bytes = DigestUtils.sha256(importUserDomain.getPassword());
        		String encodePassword = CodecUtils.toHexString(bytes);
                user.setPassword(encodePassword);
                list.add(user);
            }
        }
        this.saveBatch(list);
        return list.size();
    }
}
